<template>
  <div class="q-pa-md row items-start q-gutter-md">
    <q-card background="#000000">
      <q-btn @click="back">
        <i class="fa-solid fa-arrow-left"></i>
      </q-btn>
      <div class="d-flex flex-no-wrap justify-left">
        <div>
          <q-card-section>
            <div class="text-h6">{{ item.nick }}</div>
            <div class="text-subtitle2">
              {{ `${item.age} ${years(item.age)}` }}
            </div>
          </q-card-section>

          <q-btn
            @click="handleMessage"
            class="ml-2 mt-3 message"
            fab
            height="40px"
            right
            width="40px"
          >
            <i class="fa-solid fa-comment"></i>
          </q-btn>
          <q-btn
            @click="handleWave"
            class="ml-2 mt-3 hand"
            fab
            height="40px"
            right
            width="40px"
          >
            <i class="fa-regular fa-hand"></i>
          </q-btn>

          <div>
            <h6>O sobie:</h6>
            {{ item.about }}
          </div>
        </div>

        <q-img
          width="70vw"
          @click="
            () => {
              photoSelected = item.photo;
            }
          "
          :src="item.photo"
        />

        <q-img
          v-for="(photo, index) in item.restPhotos"
          :key="index"
          width="auto"
          height="125"
          @click="
            () => {
              photoSelected = photo;
            }
          "
          :src="photo"
        />
        <br />
      </div>
    </q-card>

    <PhotoComponent
      v-if="photoSelected"
      @close="
        () => {
          photoSelected = undefined;
        }
      "
      :photo="photoSelected"
    />
  </div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { useRouter, useRoute } from 'vue-router';

import { api } from '../boot/axios';
import years from '../components/helpers/years';
import { useUserStore } from '../stores/user';

defineOptions({
  name: 'PersonDetails',
});

const router = useRouter();
const route = useRoute();
const store = useUserStore();
const { user } = store;
interface Item {
  nick?: string;
  age?: number;
  photo?: string;
  restPhotos?: string;
  about?: string;
}

const item = ref<Item>({
  nick: route.query.nick as string,
});
const photoSelected = ref<string | undefined>(undefined);

api
  .post('/user/get-by-nick', { uuid: user.uuid, nick: route.query.nick })
  .then(({ data }) => {
    item.value.age = data.age;
    item.value.photo = data.photos.profile;
    item.value.restPhotos = data.photos.rest;
    item.value.about = data.about;
  })
  .catch((err) => {
    console.error(err);
  });

function back() {
  const menuPath = route.query.menu;

  // If menuPath is an array, take the first value, or if it's a string, use it directly
  let path = '';

  if (Array.isArray(menuPath)) {
    path = menuPath[0] || ''; // Use the first item in the array or fallback to an empty string
  } else if (typeof menuPath === 'string') {
    path = menuPath; // If it's a string, use it directly
  } else {
    path = '/default-path'; // Fallback to a default path if it's null or undefined
  }

  router.push({ path });
}

function handleMessage() {
  router.push({
    path: '/communicatorPage',
    query: { nick: item.value.nick, operation: 'message' },
  });
}

function handleWave() {
  router.push({
    path: '/communicatorPage',
    query: { nick: item.value.nick, operation: 'wave' },
  });
}

//       uuid: this.$store.state.user.uuid, nick: this.$route.query.nick
//     }
//     ).then(({ data }) => {
//       this.item.age = data.age;
//       this.item.photo = data.photos.profile;
//       this.item.restPhotos = data.photos.rest;
//       this.item.about = data.about;
//     }).catch(err => {
//       console.error(err);
//     });

// export default {
//   data() {
//     return {
//       item: {
//         nick: this.$route.query.nick,
//         age: null,
//         photo: null,
//         restPhotos: null,
//         about: null
//       },
//       photoSelected: null,

//     }
//   },

//   mounted() {

//     this.$axios.post(this.$config.serverUrl + '/user/get-by-nick', {
//       uuid: this.$store.state.user.uuid, nick: this.$route.query.nick
//     }
//     ).then(({ data }) => {
//       this.item.age = data.age;
//       this.item.photo = data.photos.profile;
//       this.item.restPhotos = data.photos.rest;
//       this.item.about = data.about;
//     }).catch(err => {
//       console.error(err);
//     });
//   },

//   methods: {
//     years,
//     handleMessage() {
//       this.$router.push({ path: '/profile', query: { nick: this.item.nick, operation: 'message' } })
//     },

//     handleWave() {
//       this.$router.push({ path: '/profile', query: { nick: this.item.nick, operation: 'wave' } })
//     }
//   },

// }
</script>
<style lang="scss" scoped>
h6 {
  margin: 20px;
}
div:has(h6) {
  margin: 20px;
}
.message {
  &:hover {
    animation: tilt-enlarging alternate 0.5s;
  }
}

.hand {
  &:hover {
    animation: tilt-shaking alternate 0.5s;
  }
}

.v-responsive {
  width: 125px !important;
  transform: translateY(12px);
}

@keyframes tilt-enlarging {
  0% {
    transform: scale(1);
  }

  25% {
    transform: scale(1.5);
  }

  50% {
    transform: scale(1);
  }

  75% {
    transform: scale(1.5);
  }

  100% {
    transform: scale(1);
  }
}

@keyframes tilt-shaking {
  0% {
    transform: rotate(0deg) scale(1);
  }

  25% {
    transform: rotate(15deg) scale(1.5);
  }

  50% {
    transform: rotate(0eg) scale(1);
  }

  75% {
    transform: rotate(-15deg) scale(1.5);
  }

  100% {
    transform: rotate(0deg) scale(1);
  }
}
</style>
